import { ProtectPlatform } from "./protect-platform.js";
export declare class FfmpegCodecs {
    private _gpuMem;
    private _ffmpegVersion;
    private readonly log;
    private readonly platform;
    private readonly videoProcessor;
    private readonly videoProcessorCodecs;
    private readonly videoProcessorHwAccels;
    constructor(platform: ProtectPlatform);
    probe(): Promise<boolean>;
    hasDecoder(codec: string, decoder: string): boolean;
    hasEncoder(codec: string, encoder: string): boolean;
    hasHwAccel(accel: string): boolean;
    get gpuMem(): number;
    get ffmpegVersion(): string;
    private probeFfmpegVersion;
    private probeVideoProcessorHwAccel;
    private probeVideoProcessorCodecs;
    private probeRpiGpuMem;
    private probeCmd;
}
