/// <reference types="node" />
import { ProtectEventMetadata } from "unifi-protect";
import { EventEmitter } from "node:events";
import { ProtectCamera } from "./protect-camera.js";
import { ProtectDevice } from "./protect-device.js";
import { ProtectNvr } from "./protect-nvr.js";
export declare class ProtectNvrEvents extends EventEmitter {
    private api;
    private hap;
    private log;
    private mqttPublishTelemetry;
    private nvr;
    private readonly eventTimers;
    private ufpApi;
    private ufpDeviceState;
    private platform;
    private unsupportedDevices;
    private eventsHandler;
    private ufpUpdatesHandler;
    constructor(nvr: ProtectNvr);
    private patchUfpConfigJson;
    private ufpUpdates;
    private manageDevices;
    private configureEvents;
    motionEventHandler(protectDevice: ProtectDevice, lastMotion: number, detectedObjects?: string[], metadata?: ProtectEventMetadata): void;
    private motionEventDelivery;
    doorbellEventHandler(protectDevice: ProtectCamera, lastRing: number | null): void;
}
