/// <reference types="node" />
/// <reference types="node" />
import { EventEmitter } from "node:events";
import { ProtectStreamingDelegate } from "./protect-stream.js";
export declare class RtpDemuxer extends EventEmitter {
    private delegate;
    private heartbeatTimer;
    private heartbeatMsg;
    private _isRunning;
    private log;
    private inputPort;
    readonly socket: import("dgram").Socket;
    constructor(streamingDelegate: ProtectStreamingDelegate, ipFamily: ("ipv4" | "ipv6"), inputPort: number, rtcpPort: number, rtpPort: number);
    private heartbeat;
    close(): void;
    private getPayloadType;
    private isRtpMessage;
    get isRunning(): boolean;
}
export declare class RtpPortAllocator {
    private portsInUse;
    constructor();
    private getPort;
    reservePort(ipFamily?: ("ipv4" | "ipv6"), portCount?: (1 | 2), attempts?: number): Promise<number>;
    freePort(port: number): void;
}
