/// <reference types="node" />
/// <reference types="node" />
import { EventEmitter } from "node:events";
import { ProtectCamera } from "./protect-camera.js";
export declare class ProtectTimeshiftBuffer extends EventEmitter {
    private readonly accessory;
    private buffer;
    private bufferSize;
    private channelId;
    private readonly livestream;
    private readonly log;
    private readonly nvr;
    private readonly protectCamera;
    private _isStarted;
    private _isTransmitting;
    private _segmentLength;
    constructor(protectCamera: ProtectCamera);
    private configureTimeshiftBuffer;
    start(channelId: number, lens?: number): Promise<boolean>;
    stop(): boolean;
    startTransmitting(): Promise<boolean>;
    stopTransmitting(): boolean;
    isInitSegment(segment: Buffer): boolean;
    getInitSegment(): Promise<Buffer | null>;
    get isStarted(): boolean;
    get isTransmitting(): boolean;
    get length(): number;
    set length(bufferMillis: number);
    get segmentLength(): number;
}
